#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define OPTLEN 50
#define VALUELEN 210
#define LINELEN (OPTLEN+VALUELEN)

#define COMMENT '#'

extern float Freq;
extern char HangCmd[];

void parseLine( char * line, int nLine, char * opt, char * value )
{
    int i= 0, j;

    for( i=0; i<OPTLEN-1 && line[i]!='=' && line[i]!=0 && line[i]!=' '
              && line[i]!='\t'; i++ )
    {
        opt[i]= line[i];
    }

    opt[i]= 0;

    while( line[i]==' ' || line[i]=='\t' )
    {
        i++;
    }  

    if ( line[i] != '=' )
    {
        fprintf( stderr, "Error leyendo fichero de configuracion, lnea %d\n"                   , nLine );
        exit( -1 );
    }
    
    i++;
    while( line[i]==' ' || line[i]=='\t' )
    {
        i++;
    }

    for( j=i, i=0; line[j]!='\n' && line[j]!=0; i++, j++ )
    {
        value[i]= line[j];
    }
    value[i]= 0;
}

/*
 * Returns true if line is a valid config line (no comment, no white-line)
 */
int isValid( char * line )
{
    int i= 0;

    while( line[i]==' ' || line[i]=='\t' )
        i++;    

    return line[i] != COMMENT && line[i] != 0 && line[i]!= '\n';
}

/*
 * Reads program's config from fich
 */
void loadConfig( FILE * fich )
{
    char opt[OPTLEN]
       , value[VALUELEN]
       , line[LINELEN];
    int nLine= 1;   
    char * chk;

    while( fgets( line, LINELEN-1, fich ) != NULL )
    {
        if ( isValid(line) )
        {
            parseLine( line, nLine, opt, value );
/*#ifdef DEBUG
            printf( "%d:%s=%s\n", nLine, opt, value );
#endif*/

            if ( strcmp(opt, "frecuencia") == 0 )
            {
                Freq= strtod( value, &chk );
                if ( Freq==0 && value==chk )
                {
                    fprintf( stderr , "Error leyendo fichero de configuracion, lnea %d\n", nLine );
                    fprintf( stderr, "Error: \"frecuencia\" debe ser unmero real\n" );
                    exit( -1 );
                }

            }
            else if ( strcmp(opt, "comando") == 0 )
            {
                strcpy( HangCmd, value );
            }
            else
            {
                fprintf( stderr , "Error leyendo fichero de configuracion, lnea %d\n", nLine );
                fprintf( stderr, "Error: Opcion \"%s\" desconocida\n", opt );
                exit( -1 );
            }
        }

        nLine++;
    }
}
