#include <stdio.h>
#include <fcntl.h>
#include <stdlib.h>
#include <sys/ioctl.h>
#include <linux/soundcard.h>

/*
 * Opens DSP and init it with the format, channels & speed of sampling 
 * On succes return file descriptor 
 * On failure return -1
 */ 
int initDSP( int format, int channels, int speed )
{
    int reqFormat= format, dsp;

    if ( (dsp= open("/dev/dsp", O_RDONLY)) == -1 )
    {                       
        perror( "/dev/dsp" );
        return -1;        
    }                   

    if ( ioctl(dsp, SNDCTL_DSP_SETFMT, &format) == -1 )
    {
        perror("SNDCTL_DSP_SETFMT");
        return -1;        
    }

    if ( format != reqFormat ) 
    {
        fprintf(stderr, "Can't set requested format\n");
        return -1;        
    }

    if ( ioctl(dsp, SNDCTL_DSP_CHANNELS, &channels) == -1 ) 
    {
        perror("SNDCTL_DSP_CHANNELS");
        return -1;        
    }

    if ( ioctl(dsp, SNDCTL_DSP_SPEED, &speed) == -1 ) 
    {
        perror("SNDCTL_DSP_SPEED");
        return -1;        
    }

    return dsp;
}

